summaryrefslogtreecommitdiff
path: root/test/integration/test-apt-update-reporting
diff options
context:
space:
mode:
authorMichael Vogt <mvo@ubuntu.com>2016-03-15 14:50:37 +0100
committerMichael Vogt <mvo@debian.org>2016-03-16 17:52:40 +0100
commitfb193b1cd43f0e8c3b7e5f69f183b9abe7e83761 (patch)
treef0ef684a93cf8f18ee95e1b4acc635a6722ac7b4 /test/integration/test-apt-update-reporting
parent8e0c56db82fe10b0f8ceadf3187ffc672eaaff3a (diff)
Get accurate progress reporting in apt update again
For the non-pdiff case, we have can have accurate progress reporting because after fetching the {,In}Release files we know how many IndexFiles will be fetched and what size they have. Therefore init the filesize early (in pkgAcqIndex::Init) and ensure that in Acquire::Pulse() looks at already downloaded bits when calculating the progress in Acquire::Pulse. Also improve debug output of Debug::acquire::progress
Diffstat (limited to 'test/integration/test-apt-update-reporting')
-rwxr-xr-xtest/integration/test-apt-update-reporting31
1 files changed, 31 insertions, 0 deletions
diff --git a/test/integration/test-apt-update-reporting b/test/integration/test-apt-update-reporting
new file mode 100755
index 000000000..bc1d119a1
--- /dev/null
+++ b/test/integration/test-apt-update-reporting
@@ -0,0 +1,31 @@
+#!/bin/sh
+set -e
+
+TESTDIR="$(readlink -f "$(dirname "$0")")"
+. "$TESTDIR/framework"
+setupenvironment
+configarchitecture 'amd64'
+
+for i in $(seq 100); do
+ insertpackage 'unstable' "foo-$i" 'all' '1.0'
+ insertsource 'unstable' "foo-$i" 'all' '1.0'
+done
+
+setupaptarchive --no-update
+changetowebserver
+
+aptget update -o Debug::Acquire::Progress=1 2>progress.log >ignore.out
+
+prev_percent=0.0
+while read line; do
+ percent="$(echo "$line"|cut -b2-6)"
+ # need to cut the decimal point and digits because sh can not do
+ # float compare
+ if [ "${percent%%.*}" -lt "${prev_percent%%.*}" ]; then
+ echo "progress goes backwards"
+ cat progress.log
+ exit 1
+ fi
+ prev_percent="$percent"
+done < progress.log
+